import { BooleanFilterModelNames } from '../../named-model.model.js';

/**
 * Type guard to check if a filter is a {@link BooleanFilter}.
 *
 * @param filter - The filter to check.
 *
 * @returns True if the filter is a {@link BooleanFilter}, false otherwise.
 *
 * @public
 */
function isBooleanFilter(filter) {
    return BooleanFilterModelNames.includes(filter.modelName);
}

export { isBooleanFilter };
