## API Report File for "@empathyco/x-types"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

// @public
export interface Banner extends NamedModel<'Banner'>, Identifiable, Taggable {
    image: string;
    title: string;
    url: string;
}

// @public
export const BannerSchema: Banner;

// @public
export interface BooleanFilter extends FacetFilter {
    label: string;
    modelName: BooleanFilterModelName;
    totalResults?: number;
}

// @public
export type BooleanFilterModelName = typeof BooleanFilterModelNames[number];

// @public
export const BooleanFilterModelNames: readonly ["SimpleFilter", "HierarchicalFilter", "NumberRangeFilter"];

// @public
export const BooleanFilterSchema: BooleanFilter;

// @public
export interface EditableNumberRangeFacet extends Facet {
    filters: EditableNumberRangeFilter[];
    modelName: 'EditableNumberRangeFacet';
}

// @public
export const EditableNumberRangeFacetSchema: EditableNumberRangeFacet;

// @public
export interface EditableNumberRangeFilter extends FacetFilter {
    modelName: 'EditableNumberRangeFilter';
    range: RangeValue;
}

// @public
export const EditableNumberRangeFilterSchema: EditableNumberRangeFilter;

// @public
export interface ExtraParamsRequest {
    // (undocumented)
    extraParams: {
        [key: string]: unknown;
    };
}

// @public
export interface Facet extends NamedModel<FacetModelName>, Identifiable {
    filters: Filter[];
    label: string;
}

// @public
export interface FacetFilter extends Filter {
    facetId: Facet['id'];
    modelName: Exclude<FilterModelName, 'RawFilter'>;
}

// @public
export const FacetFilterSchema: FacetFilter;

// @public
export type FacetModelName = 'SimpleFacet' | 'HierarchicalFacet' | 'NumberRangeFacet' | 'EditableNumberRangeFacet';

// @public
export const FacetSchema: Facet;

// @public
export interface Filter extends NamedModel<FilterModelName>, Identifiable {
    selected: boolean;
}

// @public
export interface FilterableRequest {
    // (undocumented)
    filters?: Record<string, Filter[]>;
}

// @public
export type FilterModelName = BooleanFilterModelName | 'EditableNumberRangeFilter' | 'RawFilter';

// @public
export const FilterSchema: Filter;

// @public
export interface HierarchicalFacet extends Facet {
    filters: HierarchicalFilter[];
    modelName: 'HierarchicalFacet';
}

// @public
export const HierarchicalFacetSchema: HierarchicalFacet;

// @public
export interface HierarchicalFilter extends BooleanFilter {
    children?: Filter['id'][];
    modelName: 'HierarchicalFilter';
    parentId: Filter['id'] | null;
}

// @public
export const HierarchicalFilterSchema: HierarchicalFilter;

// @public
export interface HistoryQuery extends Previewable, NamedModel<'HistoryQuery'> {
    timestamp: number;
}

// @public
export const HistoryQuerySchema: HistoryQuery;

// @public
export interface Identifiable<ID = string | number> {
    id: ID;
}

// @public
export interface IdentifierResultsRequest extends QueryableRequest, PageableRequest, TrackableRequest, ExtraParamsRequest {
}

// @public
export interface IdentifierResultsResponse {
    // (undocumented)
    results: Result[];
}

// @public
export function isBooleanFilter(filter: Filter): filter is BooleanFilter;

// @public
export function isEditableNumberRangeFacet(facet: Facet): facet is EditableNumberRangeFacet;

// @public
export function isEditableNumberRangeFilter(filter: Filter): filter is EditableNumberRangeFilter;

// @public
export function isFacetFilter(filter: Filter): filter is FacetFilter;

// @public
export function isHierarchicalFacet(facet: Facet): facet is HierarchicalFacet;

// @public
export function isHierarchicalFilter(filter: Filter): filter is HierarchicalFilter;

// @public
export function isNumberRangeFacet(facet: Facet): facet is NumberRangeFacet;

// @public
export function isNumberRangeFilter(filter: Filter): filter is NumberRangeFilter;

// @public
export function isRawFilter(filter: Filter): filter is RawFilter;

// @public
export function isSimpleFacet(facet: Facet): facet is SimpleFacet;

// @public
export function isSimpleFilter(filter: Filter): filter is SimpleFilter;

// @public
export type ModelNameType = 'Result' | 'NextQueries' | 'NextQuery' | 'RelatedTag' | 'PopularSearch' | 'QuerySuggestion' | 'HistoryQuery' | 'Banner' | 'Promoted' | 'Redirection' | FilterModelName | FacetModelName | string;

// @public
export interface NamedModel<T extends ModelNameType = ModelNameType> {
    readonly modelName: T;
}

// @public
export interface NextQueries extends NamedModel<'NextQueries'>, Identifiable {
    nextQueries: NextQuery[];
}

// @public
export interface NextQueriesRequest extends QueryableRequest, PageableRequest, ExtraParamsRequest {
}

// @public
export interface NextQueriesResponse {
    // (undocumented)
    nextQueries: NextQuery[];
}

// @public
export interface NextQuery extends NamedModel<'NextQuery'>, Required<Previewable> {
    isCurated?: boolean;
}

// @public
export const NextQuerySchema: NextQuery;

// @public
export interface NumberRangeFacet extends Facet {
    filters: NumberRangeFilter[];
    modelName: 'NumberRangeFacet';
}

// @public
export const NumberRangeFacetSchema: NumberRangeFacet;

// @public
export interface NumberRangeFilter extends BooleanFilter {
    modelName: 'NumberRangeFilter';
    range: RangeValue;
}

// @public
export const NumberRangeFilterSchema: NumberRangeFilter;

// @public
export interface PageableRequest {
    // (undocumented)
    rows?: number;
    // (undocumented)
    start?: number;
}

// @public
export interface PartialResult extends Previewable {
    results: Result[] | null;
    totalResults: number | null;
}

// @public
export interface PopularSearchesRequest extends PageableRequest, ExtraParamsRequest {
}

// @public
export interface PopularSearchesResponse {
    // (undocumented)
    suggestions: Suggestion[];
}

// @public
export interface Previewable {
    facets?: Facet[];
    query: string;
    results?: Result[] | null;
    totalResults?: number | null;
}

// @public
export interface Promoted extends NamedModel<'Promoted'>, Identifiable, Taggable {
    image: string;
    title: string;
    url: string;
}

// @public
export const PromotedSchema: Promoted;

// @public
export interface QueryableRequest {
    // (undocumented)
    query: string;
}

// @public
export interface QuerySuggestionsRequest extends QueryableRequest, PageableRequest, ExtraParamsRequest {
}

// @public
export interface QuerySuggestionsResponse {
    // (undocumented)
    suggestions: Suggestion[];
}

// @public
export interface RangeValue {
    max: number | null;
    min: number | null;
}

// @public
export interface RawFilter extends Filter {
    id: string;
    modelName: 'RawFilter';
    selected: true;
}

// @public
export const RawFilterSchema: RawFilter;

// @public
export const RecommendationSchema: Result;

// @public
export interface RecommendationsRequest extends PageableRequest, TrackableRequest, ExtraParamsRequest {
}

// @public
export interface RecommendationsResponse {
    // (undocumented)
    results: Result[];
}

// @public
export interface Redirection extends NamedModel<'Redirection'>, Identifiable, Taggable {
    url: string;
}

// @public
export const RedirectionSchema: Redirection;

// @public
export interface RelatedTag extends NamedModel<'RelatedTag'>, Previewable {
    isCurated?: boolean;
    tag: string;
}

// @public
export const RelatedTagSchema: RelatedTag;

// @public
export interface RelatedTagsRequest extends QueryableRequest, PageableRequest, ExtraParamsRequest {
}

// @public
export interface RelatedTagsResponse {
    // (undocumented)
    relatedTags: RelatedTag[];
}

// @public
export interface Result extends NamedModel<'Result'>, Identifiable, Taggable {
    identifier: ResultIdentifier;
    images: string[];
    isWishlisted: boolean;
    name: string;
    price: ResultPrice;
    rating: ResultRating;
    type: string;
    url: string;
}

// @public
export interface ResultIdentifier {
    value: string;
}

// @public
export interface ResultPrice {
    hasDiscount: boolean;
    originalValue: number;
    value: number;
}

// @public
export interface ResultRating {
    value: number | null;
}

// @public
export const ResultSchema: Result;

// @public
export interface SearchRequest extends QueryableRequest, FilterableRequest, PageableRequest, SortableRequest, TrackableRequest, ExtraParamsRequest {
}

// @public
export interface SearchResponse {
    // (undocumented)
    banners?: Banner[];
    // (undocumented)
    facets?: Facet[];
    // (undocumented)
    partialResults?: PartialResult[];
    // (undocumented)
    promoteds?: Promoted[];
    // (undocumented)
    queryTagging: TaggingRequest;
    // (undocumented)
    redirections?: Redirection[];
    // (undocumented)
    results: Result[];
    // (undocumented)
    spellcheck?: string;
    // (undocumented)
    totalResults: number;
}

// @public
export interface SimpleFacet extends Facet {
    filters: SimpleFilter[];
    modelName: 'SimpleFacet';
}

// @public
export const SimpleFacetSchema: SimpleFacet;

// @public
export interface SimpleFilter extends BooleanFilter {
    modelName: 'SimpleFilter';
}

// @public
export const SimpleFilterSchema: SimpleFilter;

// @public
export type Sort = string;

// @public
export interface SortableRequest {
    // (undocumented)
    sort?: Sort;
}

// @public
export interface Suggestion extends NamedModel<'QuerySuggestion' | 'PopularSearch'>, Previewable {
    facets: Facet[];
    isCurated?: boolean;
    // @deprecated
    key: string;
}

// @public
export const SuggestionSchema: Suggestion;

// @public
export interface Taggable {
    tagging: Tagging;
}

// @public
export const TaggableSchema: Taggable;

// @public
export interface Tagging {
    [key: string]: TaggingRequest | undefined;
    add2cart?: TaggingRequest;
    checkout?: TaggingRequest;
    click?: TaggingRequest;
    query?: TaggingRequest;
    wishlist?: TaggingRequest;
}

// @public
export interface TaggingRequest {
    params: Record<string, string | number | boolean>;
    url: string;
}

// @public
export const TaggingRequestSchema: TaggingRequest;

// @public
export const TaggingSchema: Tagging;

// @public
export interface TrackableRequest {
    // (undocumented)
    origin?: string;
}

// @public
export interface TrackableShowResponse {
    // (undocumented)
    showTagging: TaggingRequest;
}

// @public
export interface UserInfo {
    session: string;
    user: string;
    userType: string;
}

```
